<template>
  <div class="app-container">
    <!-- 列表 -->
    <!-- 搜索 -->
    <page-search
      ref="searchRef"
      :search-config="searchConfig"
      @query-click="handleQueryClick"
      @reset-click="handleResetClick"
    />
    <!-- 列表 -->
    <page-content
      ref="contentRef"
      :content-config="contentConfig"
      @add-click="handleAddClick"
      @edit-click="handleEditClick"
      @export-click="handleExportClick"
      @search-click="handleSearchClick"
      @toolbar-click="handleToolbarClick"
      @operat-click="handleOperatClick"
      @filter-change="handleFilterChange"
    >
      <template #status="scope">
        <el-tag :type="scope.row[scope.prop] == 1 ? 'success' : 'info'">
          {{ scope.row[scope.prop] == 1 ? "启用" : "禁用" }}
        </el-tag>
      </template>
      <template #options="scope">
        {{ returnOptionsLabel(scope.prop, scope.row[scope.prop]) }}
      </template>
      <template #gender="scope">
        <DictLabel v-model="scope.row[scope.prop]" code="gender" />
      </template>
      <template #mobile="scope">
        <el-text>{{ scope.row[scope.prop] }}</el-text>
        <copy-button
          v-if="scope.row[scope.prop]"
          :text="scope.row[scope.prop]"
          style="margin-left: 2px"
        />
      </template>
    </page-content>

    <!-- 新增 -->
    <page-modal ref="addModalRef" :modal-config="addModalConfig" @submit-click="handleSubmitClick">
      <template #formFooter>
        <selectPermission
          v-model="selPermissionList"
          :list="permissionList"
          ref="refSelectPermission"
        ></selectPermission>
      </template>
    </page-modal>

    <!-- 编辑 -->
    <page-modal
      ref="editModalRef"
      :modal-config="editModalConfig"
      @submit-click="handleSubmitClick"
    >
      <template #formFooter>
        <selectPermission
          v-model="selPermissionList"
          :list="permissionList"
          ref="refSelectPermission"
        ></selectPermission>
      </template>
    </page-modal>
  </div>
</template>

<script setup lang="ts">
import type { IObject, IOperatData } from "@/components/CURD/types";
import usePage from "@/components/CURD/usePage";
import addModalConfig from "./config/add";
import contentConfig from "./config/content";
import editModalConfig from "./config/edit";
import searchConfig from "./config/search";
import { returnOptionsLabel } from "./config/config";
import RoleApi, { type SysRole } from "@/api/account/role";
import ShopStaffApi from "@/api/account/shopStaff";
import permissionApi, { type ShopPermission } from "@/api/account/permission";
import selectPermission from "./components/select-permission.vue";
const refSelectPermission = ref();

const {
  searchRef,
  contentRef,
  addModalRef,
  editModalRef,
  handleQueryClick,
  handleResetClick,
  // handleAddClick,
  // handleEditClick,
  handleSubmitClick,
  handleExportClick,
  handleSearchClick,
  handleFilterChange,
} = usePage();

//店铺权限列表
let permissionList = ref<ShopPermission[]>([]);
//选中的权限列表
let selPermissionList = ref<string[]>([]);
// 数据初始化
async function init() {
  // 覆写添加确定方法
  const oldAddSubmitFunc = addModalConfig.formAction;
  addModalConfig.formAction = (data) => {
    return oldAddSubmitFunc({
      ...data,
      shopPermissionIds: selPermissionList.value.reduce((pre: string[], cur: string) => {
        return pre.concat(cur);
      }, [] as string[]),
    });
  };
  // 覆写编辑确定方法
  const oldeditSubmitFunc = editModalConfig.formAction;
  editModalConfig.formAction = (data) => {
    return oldeditSubmitFunc({
      ...data,
      shopPermissionIds: selPermissionList.value.reduce((pre: string[], cur: string) => {
        return pre.concat(cur);
      }, [] as string[]),
    });
  };

  const res = await RoleApi.getList({ page: 1, size: 100 });
  const permission = await permissionApi.getshopPermission();
  permissionList.value = Array.isArray(permission) ? permission : [];
  const roleArr = res.records.map((item: SysRole) => {
    return {
      ...item,
      label: item.name,
      value: item.id,
    };
  });
  addModalConfig.formItems[1]!.options = roleArr;
  editModalConfig.formItems[1]!.options = roleArr;
}
init();

// 新增
async function handleAddClick() {
  selPermissionList.value = [];
  addModalRef.value?.setModalVisible();
}
// 编辑
async function handleEditClick(row: IObject) {
  selPermissionList.value = [];
  editModalRef.value?.handleDisabled(false);
  editModalRef.value?.setModalVisible();
  // 设置权限选中
  const perselArr = await permissionApi.getPermission(row.id);
  for (let id of perselArr) {
    for (let index in permissionList.value) {
      const item = permissionList.value[index];
      if (item.children) {
        for (let child of item.children) {
          if (child.id != null && child.id == id) {
            if (selPermissionList.value[index]) {
              selPermissionList.value[index].push(id);
            } else {
              selPermissionList.value[index] = [id];
            }
          }
        }
      }
    }
  }
  console.log(selPermissionList.value);
  // 根据id获取数据进行填充
  await ShopStaffApi.get(row.id).then((res) => {
    console.log(res);
    editModalRef.value?.setFormData({ ...res });
  });
}
1;
// 其他工具栏
function handleToolbarClick(name: string) {
  console.log(name);
  if (name === "custom1") {
    ElMessage.success("点击了自定义1按钮");
  }
}
// 其他操作列
async function handleOperatClick(data: IOperatData) {}

// 切换示例
</script>
